﻿<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl">

  <xsl:template match="/">
    <xsl:param name="nodename"/>
    <xsl:for-each select="/IM">
      <link>
        <xsl:value-of select="@Text"/>
      </link>
      
      <br/>
      <xsl:call-template name="sub">
        <xsl:with-param name="nodename" select="//IM/*"></xsl:with-param>        
      </xsl:call-template>
    </xsl:for-each>
  </xsl:template>


  <xsl:variable name="link1">
      <xsl:attribute name="id">
                <xsl:value-of select="name()" />
              </xsl:attribute>              
              <!--节点文本-->
              <a>
                <xsl:attribute  name="id">
                  <xsl:value-of select="concat(name(),'_a')"/>
                </xsl:attribute>
                <!--鼠标经过事件-->
                <xsl:attribute name="onmouseover">
                  show_refresh('<xsl:value-of select="concat(name(),'_a')"/>')
                </xsl:attribute>
                <xsl:attribute name="onmouseout">
                  hidden_refresh('<xsl:value-of select="concat(name(),'_a')"/>')
                </xsl:attribute>
                <xsl:attribute name="onclick">
                  xmlCollapse1('<xsl:value-of select="concat(name(),'_img')" />','<xsl:value-of select="concat(name(),'_div')" />')
                </xsl:attribute>
                <xsl:value-of select="@Text" />
         
              </a>
  </xsl:variable>
  
  <xsl:template name="sub">
    <xsl:param name="nodename"></xsl:param>
    <xsl:for-each select="$nodename">     
     <!--火狐可能会读到空行-->
      <xsl:if test="@Name!=''">
        <xsl:variable  name="childCount">
          <!--子兄弟节点个数-->
          <xsl:value-of select="count(child::node()[@Text!=''])"/>
        </xsl:variable>
        <xsl:variable  name="brotherCount">
          <!--兄弟节点个数-->
          <xsl:value-of select="count(following-sibling::node()[@Text!=''])"/>
        </xsl:variable>
        <xsl:variable  name="parentBrotherCount">
          <xsl:value-of select="count(../following-sibling::node()[@Text!=''])"/>
        </xsl:variable>
 
        <!--生成树枝图片 其中select='.'一定要是当前对象‘.’ 而不是name() ,name()只是标签字符串！-->           
        <xsl:call-template name="getimg">
          <xsl:with-param name="nodename"  select="."></xsl:with-param>
        </xsl:call-template>         

       
      
       
        <xsl:choose>
          <!--有子节点-->
          <xsl:when test="$childCount>0">
            <img>
              <xsl:attribute name="id">
                <xsl:value-of select="concat(name(),'_img')" />
              </xsl:attribute>
              <xsl:attribute name="class">
                <xsl:value-of select="'treeimg'" />
              </xsl:attribute>
              <xsl:attribute name="src">
                <xsl:choose>
                  <xsl:when test="$brotherCount=0">
                    <xsl:value-of select="'../../images/Lplus.gif'" />
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="'../../images/Tplus.gif'" />
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
              <!--节点展开 闭合脚本-->
              <xsl:attribute name="onclick">
                xmlCollapse1('<xsl:value-of select="concat(name(),'_img')" />','<xsl:value-of select="concat(name(),'_div')" />')
              </xsl:attribute>
            </img>
            
             <link>
               
              <xsl:attribute name="id">
                <xsl:value-of select="name()" />
              </xsl:attribute>              
              <!--节点文本-->
              <a>
                <xsl:attribute  name="id">
                  <xsl:value-of select="concat(name(),'_a')"/>
                </xsl:attribute>
                <!--鼠标经过事件-->
                <xsl:attribute name="onmouseover">
                  show_refresh('<xsl:value-of select="concat(name(),'_a')"/>')
                </xsl:attribute>
                <xsl:attribute name="onmouseout">
                  hidden_refresh('<xsl:value-of select="concat(name(),'_a')"/>')
                </xsl:attribute>
                <xsl:attribute name="onclick">
                  xmlCollapse1('<xsl:value-of select="concat(name(),'_img')" />','<xsl:value-of select="concat(name(),'_div')" />')
                </xsl:attribute>
                <xsl:value-of select="@Text" />
             
              </a>
            </link>
          </xsl:when>
          <!--没有子节点 末端节点id-->
          <xsl:otherwise>
            <img>
              <xsl:attribute name="class">
                <xsl:value-of select="'treeimg'" />
              </xsl:attribute>
              <xsl:attribute name="id">
                <xsl:value-of select="concat(name(),'_img')" />
              </xsl:attribute>
              <xsl:attribute name="src">
                <xsl:choose>
                  <xsl:when test="$brotherCount=0">
                    <xsl:value-of select="'../../images/L.gif'" />
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="'../../images/T.gif'" />
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
            <link>
            <xsl:attribute name="id">
              <xsl:value-of select="concat(name(),'_',@Text)" />
            </xsl:attribute> 
            <a>
              <xsl:attribute name="onclick">
                linkclick1('<xsl:value-of select="@OnClick"/>')
              </xsl:attribute>
              <xsl:value-of select="@Text" />
            </a>
            </link>
          </xsl:otherwise>
        </xsl:choose>        
       
      
      <br/>    
        
        <!--子节点数目>0 递归-->  
        <xsl:choose>
          <xsl:when test="$childCount>0">
            <div>
            <xsl:attribute name="id">
              <xsl:value-of select="concat(name(),'_div')" />
            </xsl:attribute>
              <xsl:attribute name="class">
                <xsl:value-of select="'subdiv'"/>
              </xsl:attribute>
            
            <xsl:call-template name="sub">
              <xsl:with-param name="nodename" select="child::node()[@Text!='']"></xsl:with-param>
            </xsl:call-template>
            </div>
          </xsl:when>
          <xsl:otherwise>            
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
    </xsl:for-each>  
  
  </xsl:template>
  <xsl:template  name="getimg">
    <xsl:param name="nodename"></xsl:param>
    <xsl:variable name="follwCount">
      <!--父节点兄弟节点个数-->
      <xsl:value-of select="count($nodename/parent::node()/following-sibling::node()[@Text!=''])"/>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="$nodename/parent::node()/@Name!='IM'">
        <!--<xsl:value-of select="$follwCount"/>-->
        <xsl:if test="$follwCount>0">       

          <xsl:call-template name="getimg">
            <xsl:with-param  name="nodename" select="$nodename/parent::node()"></xsl:with-param>
          </xsl:call-template>
          <img>
            <xsl:attribute name="class">
              <xsl:value-of select="'treeimg'" />
            </xsl:attribute>
            <xsl:attribute name="src">
              <xsl:value-of select="'../../images/I.gif'" />
            </xsl:attribute>
          </img>
        </xsl:if>
        <xsl:if test="$follwCount=0">
          <xsl:call-template name="getimg">
            <xsl:with-param  name="nodename" select="$nodename/parent::node()"></xsl:with-param>
          </xsl:call-template>
          <img>
            <xsl:attribute name="class">
              <xsl:value-of select="'treeimg'" />
            </xsl:attribute>
            <xsl:attribute name="src">
              <xsl:value-of select="'../../images/blank.gif'" />
            </xsl:attribute>
          </img>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
 
</xsl:stylesheet>